package model

import (
	"github.com/slicebit/qb"
)

// RawSQL returns a RawSQLBuilder from a string and optionnaly bindings
func RawSQL(s string, bindings ...interface{}) RawSQLBuilder {
	return RawSQLBuilder{s, bindings}
}

// RawSQLBuilder implements qb.Builder
type RawSQLBuilder struct {
	s        string
	bindings []interface{}
}

// Build creates a statement
func (b RawSQLBuilder) Build(dialect qb.Dialect) *qb.Stmt {
	s := qb.Statement()
	s.AddSQLClause(b.s)
	if len(b.bindings) != 0 {
		s.AddBinding(b.bindings...)
	}
	return s
}
